		/*This file has the routines for managing and*/
		/*freeing memory cells*/
int freeptr, *freep;
	/*freep keeps indices of the cells in the heap which are free */
	/*It is a stack, with the top being pointed to by freeptr */

getfreecell(cellpool)

struct heapcell cellpool[];
{
 if (freeptr > NUMOFCELL)
	garbage_collector(cellpool);
			/*if there are no free cells then the */
			/*garbage collector will hopefully get some*/
 if (freeptr > NUMOFCELL)
		/*garbage collector failed to get any freecell so abort*/
	{ printf("No Heap Space : Retry with more heap space or reset\n");
	  longjmp(parserrbuff, 0);
	}
 else
 	return(freep[freeptr++]);
}

/*return_cell takes a pointer to a heap cell and puts it back on freep*/

free_cell(p)
cellptrtype p;
	{
	 --freeptr;
	 freep[freeptr] = p;
	}

garbage_collector(cellpool)
struct heapcell cellpool[];
{
 printf("GCing....\n");
 return(0);
}


initfreep()
{ 
  int i;

  freeptr = 0;
  for(i=0;i<NUMOFCELL;i++)
	freep[i]=i;
}

struct molecule *get_molecule()

{ struct molecule *molptr;
  if (next_mol->next != NULL)
	{molptr = next_mol; 
	 next_mol = next_mol->next;
	 return(molptr);
	}
  else 
	{molptr = (struct molecule *) 
				calloc(2000, sizeof(struct molecule));
	 for(i = 0; i < 1999; i++)
		molptr[i].next = molptr + i + 1;  
			      /*next field points to next entry in the array*/
	 molptr[1999].next = NULL;
	 next_mol->next = molptr;
	 molptr = next_mol;
	 next_mol = next_mol->next;
	 return(molptr);
	};
}
